// `ƒʉߓ_w̐ڐvZ
// Ȑ̍WxֈړȐ̓_Ǝwʉߓ_Spx̉]ڐ̌X΂̋ߎlvZ܂B
// vŹAeՂɔołA܂łvZłB
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.Series,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Series3: TPointSeries;
    Series4: TPointSeries;
    BitBtn2: TBitBtn;
    Series2: TLineSeries;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure LabeledEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    LabeledEdit : array[1..7] of TLabeledEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Velthuis.Bigdecimals, Velthuis.bigintegers, big_Math;

// f(t) = (t-3)^2-2    or    f(t) = -((t-3)^2-2)
// x, y ڐwʉߓ_W@
// y=(2t-6)(x-t) + t^2-6t+7
// y=2xt-6x-2t^2+6t+t^2-6t+7
// y=-t^2+2xt-6x+7
// t^2-2xt+6x-7+y= 0    or   t^2-2xt+6x-7-y= 0
function parabola_tangent(x, y: bigdecimal; var t1, t2: bigdecimal): boolean;
var
  a, b, c, d: bigdecimal;
  one, two, four, six, seven : bigdecimal;
begin
  if Form1.CheckBox1.Checked then y := -y;
  one := '1';
  two := '2';
  four := '4';
  six := '6';
  seven := '7';
  a := one;
  b := - two * x;
  c := six * x - seven + y;
  d := b * b - four * a * c;
  result := true;
  if d < 0 then begin
    result := false;
    exit;
  end;
  d := bigdecimal.Sqrt(d, bigdecimal.DefaultPrecision);
  t1 := (-b + d) / 2 / a;
  t2 := (-b - d) / 2 / a;
end;

// ֐f(x)̌vZ@`
// f(x) = (x-3)^2 - 2  or f(x) = (x-3)^3 - 2
function f(x: bigdecimal): bigdecimal;
begin
  if Form1.Radiobutton2.Checked = true then
    result := (x - 3) * (x - 3) * (x - 3) - 2
  else
    result := (x - 3) * (x - 3) - 2;
  if form1.CheckBox1.Checked = true then result := -result;
  // Zɂ茅ꍇ̂ŃftHgɊۂ
  result := result.RoundToPrecision(bigdecimal.DefaultPrecision);
end;

//  ڐ̍}
// x, y ڐʉߍW
// a    ڐX
procedure line_segment(x, y, a, gl, gr: bigdecimal);
var
  c : bigdecimal;
begin
  c := y - a * x;                     // y = x + c
  if gl < x then begin
    y := a * gl + c;
    form1.Series2.AddXY(bigdecimaltodouble(gl), bigdecimaltodouble(y));
  end
  else begin
    y := a * x + c;
    form1.Series2.AddXY(bigdecimaltodouble(x), bigdecimaltodouble(y));
  end;
  y := a * gr + c;
  Form1.Series2.AddXY(bigdecimaltodouble(gr), bigdecimaltodouble(y));
  Form1.Memo1.Lines.Append('ڐ');
  if c >= bigdecimal.Zero then begin
    Form1.Memo1.Lines.Append(' y = ' + a.ToString + 'x');
    Form1.Memo1.Lines.Append('       +' +  c.ToString);
  end
  else begin
    Form1.Memo1.Lines.Append(' y = ' + a.ToString + 'x');
    Form1.Memo1.Lines.Append('       ' + c.ToString);
  end;
end;

// [gl,gr]̊֐f(x)̃Ot}
procedure chart_graph(gl, gr: bigdecimal);
const
  n = 100;
var
  x, dx: bigdecimal;
  y : double;
  i : integer;
begin
  Form1.series1.clear;                            // `ɂȐ
  Form1.series2.clear;                            // ڐ
  Form1.series3.clear;                            // _ƌ͈͏
  Form1.series4.clear;                            // ԊuƐړ_Aʉߓ_
  if gl = gr then exit;                           // ͈͂[I
  dx := (gr - gl) / n;
  for i := 0 to n do begin
    x := gl + i * dx;
    y := bigdecimaltodouble(f(x));
    Form1.series1.AddXY(bigdecimaltodouble(x), y);
  end;
end;

const
  orthants = '10';                    // یׂtO

// (xp,yp)_ɑ΂(ex,ey) px - (sx,sy) px  { E|
// sx, sy `̑O̍W
// ex, ey `̌̍W
// xp, yp ڐ̒ʉߎwW
function gradient_difference(sx, sy, ex, ey, xp, yp: bigdecimal): bigdecimal;
var
  sf, ef : integer;  // 1, 2, 3, 4 ی  xp, yp _Ƃsx,sy ex,ey̏ی
  sdx, sdy, edx, edy : bigdecimal;   // x, y 
  salpha, ealpha : bigdecimal;       // X
begin
  result := 0;
  // ʉߓ_(_)ɑ΂鍷
  sdx := sx - xp;
  sdy := sy - yp;
  edx := ex - xp;
  edy := ey - yp;
  sf := 0;
  ef := 0;
  // eW̌_(xp,yp)ɑ΂ی
  if (sdx >= 0) and (sdy >= 0) then sf := 1;
  if (sdx <  0) and (sdy >= 0) then sf := 2;
  if (sdx <  0) and (sdy <  0) then sf := 3;
  if (sdx >= 0) and (sdy <  0) then sf := 4;
  if (edx >= 0) and (edy >= 0) then ef := 1;
  if (edx <  0) and (edy >= 0) then ef := 2;
  if (edx <  0) and (edy <  0) then ef := 3;
  if (edx >= 0) and (edy <  0) then ef := 4;
  // pxrad +y 0`΁@-y 0`-
  salpha := arctan2_big(sdy, sdx);
  ealpha := arctan2_big(edy, edx);
  // (rad)vZ
  if sf = 1 then begin
    if (ef = 1) or (ef = 2) then result := ealpha - salpha;
    if ef = 4 then result := ealpha - salpha;
  end;
  if sf = 2 then begin
    if (ef = 2) or (ef = 1) then result := ealpha - salpha;
    if ef = 3 then result := pi_big + pi_big + ealpha - salpha;
  end;
  if sf = 3 then begin
    if (ef = 3) or (ef = 4) then result := ealpha - salpha;
    if ef = 2 then result := ealpha - pi_big - pi_big - salpha;
  end;
  if sf = 4 then begin
    if (ef = 4) or (ef = 3) then result := ealpha - salpha;
    if ef = 1 then result := ealpha - salpha;
  end;
  // ییl result > pi;
  if (sf = 1) and (ef = 3) then result := orthants;
  if (sf = 2) and (ef = 4) then result := orthants;
  if (sf = 3) and (ef = 1) then result := orthants;
  if (sf = 4) and (ef = 2) then result := orthants;
end;


const
  PLarge  = 5500;                     // Zsb`tOl
  XLimit  = 6000;                     // ͈͍őlɒBtO

// ڐ̌Ɛڐ̌XvZ
// a        Jn_
// p        rb`
// xp, yp   ڐʉߓ_
// xm       I_
// epsiron  l
// loop     vZ
// ex, ey   ړ_
// ep       l
function bisection_method(a, p, xp, yp, xm, epsilon: bigdecimal; var loop: integer; var ex, ey, ep: bigdecimal): bigdecimal;
const
  Maxloop = 5000;
var
  ea : bigdecimal;
  sx, sy, four: bigdecimal;
  defa, defb, orth : bigdecimal;
  Fl : boolean;             // ړtO
begin
  orth := orthants;
  four := '4';
  sx := a;                         // ŏxW
  sy := f(sx);                     // ŏyW
  ex := sx + p;                    // sb`ZxW
  ey := f(ex);                     // yW
  // Weś@xp,ypSɑ΂pxvZ e-s
  ea := gradient_difference(sx, sy, ex, ey, xp, yp);
  // ea̒l2یzĂI vZsb`傫I
  if ea = orth then begin
    loop := PLarge;
    result := 0;
    exit;
  end;
  Fl := true;                      // tOl
  if ea < 0 then Fl := false;      // ea |EtOl
  // ڐ[_W(ex, ey)̋ߎvZ
  repeat
    ex := sx + p;
    ey := f(ex);
    // Weś@xp,ypSɑ΂pxvZ e-s
    ea := gradient_difference(sx, sy, ex, ey, xp, yp);
    if Fl = false then begin       // E
      if ea > 0 then begin         // ɂȂ
        ex := ex - p - p;
        ey := f(ex);
        p := p / four;
      end;
    end
    else begin                     // 
      if ea < 0 then begin         // EɂȂ
        ex := ex - p - p;
        ey := f(ex);
        p := p / four;
      end;
    end;
    sx := ex;
    sy := ey;
    inc(loop);                     // [vJEg
    // x̒lőlɓBmF
    if ex > xm + p then loop := XLimit;
    ep := epsilon * (ey.Abs(ey) + ex.abs(ex) + 1);
  until (p < ep) or (loop > Maxloop);
  // ߂l ڐ̌XvZ
  defa := ey - yp;
  defb := ex - xp;
//  defa := defa.RoundToPrecision(bigdecimal.DefaultPrecision);
//  defb := defb.RoundToPrecision(bigdecimal.DefaultPrecision);
  result := defa / defb;
//  result := bigdecimal.Divide(defa, defb);
end;

// vZs
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  DIG = 40;               // Bigdecimal \
var
  a, p, alpha, xp, yp, gr, gl, xm: bigdecimal;
  loop, prec : integer;
  epsilon, ex, ey, ep : bigdecimal;
  estr : string;
  t1, t2 : bigdecimal;
begin
  a := labelededit3.Text;
  p := labelededit4.Text;
  xp := labelededit5.Text;
  xm := labelededit7.Text;
  yp := labelededit6.Text;
  gl := chart1.BottomAxis.Minimum;
  gr := chart1.BottomAxis.Maximum;
  memo1.Clear;
  // lvZ
  prec := bigdecimal.DefaultPrecision;
  prec := prec - 1;
  estr := '1e-' + intTostr(prec);
  epsilon := estr;
  // `̌vZ
  loop := 0;              // ߎvZ[v
  ep := epsilon;          // ۂ̎l
  alpha := bisection_method(a, p, xp, yp, xm, epsilon, loop, ex, ey, ep);
  if loop = XLimit then begin
    application.MessageBox('lƌ͈͂̊Ԃɐڐ͂܂B','',0);
    memo1.Clear;
    exit;
  end;
  if loop = PLarge then begin
    application.MessageBox('ԊuPĉB','',0);
    memo1.Clear;
    exit;
  end;
  // ړ_ʒuOtɒǉ
  Series4.AddXY(bigdecimaltodouble(ex), bigdecimaltodouble(ey));
  // vZʕ\
  if Radiobutton2.Checked = true then
    memo1.Lines.Append('f(x) = (x - 3)^3 - 2')
  else
    memo1.Lines.Append('f(x) = (x - 3)^2 - 2');
  memo1.Lines.Append('[v ' + intTostr(loop));
  memo1.Lines.Append('l');
  ep := ep.RoundToPrecision(DIG);
  memo1.Lines.Append(ep.ToString);
  alpha := alpha.RoundToPrecision(DIG);

  memo1.Lines.Append('= ' + alpha.ToString);
  ex := ex.RoundToPrecision(DIG);
  ey := ey.RoundToPrecision(DIG);
  memo1.Lines.Append('ړ_ x = ' + ex.ToString);
  memo1.Lines.Append('ړ_ y = ' + ey.ToString);
  // ڐ`
  line_segment(xp, yp, alpha, gl, gr);
  if Radiobutton2.Checked = false then begin
    if parabola_tangent(xp, yp, t1, t2) then begin
      memo1.Lines.Append('t1 = ' + t1.ToString);
      memo1.Lines.Append('t2 = ' + t2.ToString);
    end;
  end;
end;

// ͒lmF
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  gl, gr, glm, grm : double;
  ch : integer;
  a, xp, yp, y, p, xm: double;
begin
  val(labelededit1.Text, glm, ch);
  if ch <> 0 then begin
    application.MessageBox('OtŏlɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit2.Text, grm, ch);
  if ch <> 0 then begin
    application.MessageBox('OtEőlɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit3.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('laɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit4.Text, p, ch);
  if ch <> 0 then begin
    application.MessageBox('ԊupɊԈႢL܂B','',0);
    exit;
  end;
  if p <=0 then begin
    application.MessageBox('Ԋup̓[(0)傫ĉB','',0);
    exit;
  end;
  val(labelededit7.Text, xm, ch);
  if ch <> 0 then begin
    application.MessageBox('ɊԈႢL܂B','',0);
    exit;
  end;
  if a >= xm then begin
    application.MessageBox('͏la傫ĂB','',0);
    exit;
  end;
  val(labelededit5.Text, xp, ch);
  if ch <> 0 then begin
    application.MessageBox('̍WXɊԈႢ܂B','',0);
    exit;
  end;
  val(labelededit6.Text, yp, ch);
  if ch <> 0 then begin
    application.MessageBox('̍WYɊԈႢ܂B','',0);
    exit;
  end;
  gl := a - (xm - a) / 10;
  gr := xm + (xm - a) / 10;
  if xp < gl then gl := xp - abs(xp / 10);
  if xp > gr then gr := xp + abs(xp / 10);
  if glm < gl then gl := glm;
  if grm > gr then gr := grm;

  chart_graph(gl, gr);             // `ȐOt}

  y := bigdecimaltodouble(f(a));
  series3.AddXY(a, y);             // ʒuOtǉ
  y := bigdecimaltodouble(f(xm));
  series3.AddXY(xm, y);            // ʒuOtǉ

  application.ProcessMessages;

  if p > (xm - a) / 4 then begin
    application.MessageBox('Ԋup傫܂B','',0);
    exit;
  end;

  y := bigdecimaltodouble(f(a + p));
  series4.AddXY(a + p, y);         // vZԊuOtǉ
  series4.AddXY(xp, yp);           // ʉߎwʒuOtǉ

  bitbtn1.Enabled := True;
end;

procedure TForm1.LabeledEditChange(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
begin
  for i := low(LabeledEdit) to high(LabeledEdit) do begin
    LabeledEdit[i] := TLabeledEdit(findComponent('LabeledEdit' + intTostr(i)));
    LabeledEdit[i].OnChange := LabeledEditChange;
  end;
end;

end.
